datablock TSShapeConstructor(SantaMechDts)
{
	baseShape  = "./santamech.dts";
	sequence0  = "./sa_root.dsq root";
	sequence1  = "./sa_run.dsq run";
	sequence2  = "./sa_run.dsq walk";
	sequence3  = "./sa_back.dsq back";
	sequence4  = "./sa_side.dsq side";
	sequence5  = "./sa_root.dsq crouch";
	sequence6  = "./sa_run.dsq crouchRun";
	sequence7  = "./sa_back.dsq crouchBack";
	sequence8  = "./sa_side.dsq crouchSide";
	sequence9  = "./sa_look.dsq look";
	sequence10 = "./sa_root.dsq headside";
	sequence11 = "./sa_root.dsq headUp";
	sequence12 = "./sa_jump.dsq jump";
	sequence13 = "./sa_jump.dsq standjump";
	sequence14 = "./sa_root.dsq fall";
	sequence15 = "./sa_root.dsq land";
	sequence16 = "./sa_root.dsq armAttack";
	sequence17 = "./sa_root.dsq armReadyLeft";
	sequence18 = "./sa_root.dsq armReadyRight";
	sequence19 = "./sa_root.dsq armReadyBoth";
	sequence20 = "./sa_root.dsq spearready";  
	sequence21 = "./sa_root.dsq spearThrow";
	sequence22 = "./sa_root.dsq talk";  
	sequence23 = "./sa_Death.dsq death1"; 
	sequence24 = "./sa_root.dsq shiftUp";
	sequence25 = "./sa_root.dsq shiftDown";
	sequence26 = "./sa_root.dsq shiftAway";
	sequence27 = "./sa_root.dsq shiftTo";
	sequence28 = "./sa_root.dsq shiftLeft";
	sequence29 = "./sa_root.dsq shiftRight";
	sequence30 = "./sa_root.dsq rotCW";
	sequence31 = "./sa_root.dsq rotCCW";
	sequence32 = "./sa_root.dsq undo";
	sequence33 = "./sa_root.dsq plant";
	sequence34 = "./sa_root.dsq sit";
	sequence35 = "./sa_root.dsq wrench";
	sequence36 = "./sa_root.dsq activate";
	sequence37 = "./sa_root.dsq activate2";
	sequence38 = "./sa_root.dsq leftrecoil";
};
datablock AudioProfile(SAWalkSound)
{
   fileName = "./walk.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(SACCSound)
{
   fileName = "./candycaneshoot.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(SAPSSound)
{
   fileName = "./presentfire.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(SAPSeSound)
{
   fileName = "./presentexplode.wav";
   description = AudioClose3d;
   preload = true;
};
datablock PlayerData(SAMechArmor)
{
   renderFirstPerson = true;
   emap = false;
   className = Armor;
   shapeFile = "./santamech.dts";
   cameraMaxDist = 12;
   cameraTilt = 0.25;
   cameraVerticalOffset = 6;
   computeCRC = false;
   canObserve = true;
   cmdCategory = "Clients";
   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   minLookAngle = -1.5;
   maxLookAngle = 1.5;
   maxFreelookAngle = 3.0;
   mass = 90;
   drag = 0.1;
   maxdrag = 0.52;
   density = 0.7;
   maxDamage = 500;
   maxEnergy =  10;
   repairRate = 0.33;
   energyPerDamagePoint = 75.0;
   rechargeRate = 0.4;
   runForce = 4320;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 20;
   maxBackwardSpeed = 14;
   maxSideSpeed = 0;
   maxForwardCrouchSpeed = 0;
   maxBackwardCrouchSpeed = 0;
   maxSideCrouchSpeed = 0;
   maxForwardProneSpeed = 0;
   maxBackwardProneSpeed = 0;
   maxSideProneSpeed = 0;
   maxForwardWalkSpeed = 0;
   maxBackwardWalkSpeed = 0;
   maxSideWalkSpeed = 0;
   maxUnderwaterForwardSpeed = 4;
   maxUnderwaterBackwardSpeed = 2;
   maxUnderwaterSideSpeed = 2;
   jumpForce = 10 * 200;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;
   minJetEnergy = 0;
   jetEnergyDrain = 0;
   canJet = 0;
   recoverDelay = 0;
   recoverRunForceScale = 1.2;
   minImpactSpeed = 250;
   speedDamageScale = 3.8;
   boundingBox			= vectorScale("2 4 14", 4); //"2.5 2.5 2.4";
   crouchBoundingBox	= vectorScale("4 4 14", 4); //"2.5 2.5 2.4";
   proneBoundingBox		= vectorScale("4 4 14", 4); //"2.5 2.5 2.4";
   pickupRadius = 0.75;
   boxNormalHeadPercentage       = 0.83;
   boxNormalTorsoPercentage      = 0.49;
   boxHeadLeftPercentage         = 0;
   boxHeadRightPercentage        = 1;
   boxHeadBackPercentage         = 0;
   boxHeadFrontPercentage        = 1;
   jetEmitter = "";
   jetGroundEmitter = "";
   jetGroundDistance = 4;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;
   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;
   runSurfaceAngle  = 85;
   jumpSurfaceAngle = 86;
   minJumpSpeed = 20;
   maxJumpSpeed = 30;
   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;
   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   JumpSound			= SAWalkSound;
   FootSoftSound        = SAWalkSound;
   FootHardSound        = SAWalkSound;
   impactWaterEasy      = Splash1Sound;
   impactWaterMedium    = Splash1Sound;
   impactWaterHard      = Splash1Sound;
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   observeParameters = "0.5 4.5 4.5";
   uiName = "Santa Mech";
   rideable = true;
   lookUpLimit = 0.55;
   lookDownLimit = 0.55;
   canRide = false;
   showEnergyBar = false;
   paintable = true;
   numMountPoints = 1;
   mountThread[0] = "sit";
   mountNode[0] = 0;
};
datablock ParticleData(SACCFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.5 0.5 0.9";
	colors[1]     = "0 0 0 0.1";
	sizes[0]      = 0.5;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SACCFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SACCFlashParticle";
};
datablock ParticleData(SACCExplosionParticleA)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1500;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/chunk";
	spinSpeed		= 0;
	spinRandomMin		= 0;
	spinRandomMax		= 0;
	colors[0]     = "0.9 0 0 1";
	colors[1]     = "0.9 0 0 0";
	sizes[0]      = 0.75;
	sizes[1]      = 0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(SACCExplosionEmitterA)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SACCExplosionParticleA";

   useEmitterColors = true;
};


datablock ParticleData(SACCExplosionParticleB)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1500;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/chunk";
	spinSpeed		= 0;
	spinRandomMin		= 0;
	spinRandomMax		= 0;
	colors[0]     = "1 1 1 1";
	colors[1]     = "1 1 1 0";
	sizes[0]      = 0.75;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SACCExplosionEmitterB)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SACCExplosionParticleB";

   useEmitterColors = true;
};

datablock ExplosionData(SACCExplosion)
{
   soundProfile = bulletHitSound;

   lifeTimeMS = 100;

   particleEmitter = SACCExplosionEmitterA;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = SACCExplosionEmitterB;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "0 0 0";
   lightEndColor = "0 0 0";
};


AddDamageType("SACandyCane",   '<bitmap:add-ons/Vehicle_SantaMech/CI_CandyCane> %1',    '%2 <bitmap:add-ons/Vehicle_SantaMech/CI_CandyCane> %1',0.2,1);
datablock ProjectileData(SACandycaneProjectile)
{
   projectileShapeName = "./candycane.dts";
   directDamage        = 10;
   directDamageType    = $DamageType::SACandycane;
   radiusDamageType    = $DamageType::SACandycane;

   brickExplosionRadius = 1;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 25;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = SACCExplosion;
   particleEmitter     = "";

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 10000;
   fadeDelay           = 9000;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.5;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};
datablock ShapeBaseImageData(SACCImage)
{
   shapeFile = "./emptygun.dts";
   emap = true;
   mountPoint = 1;
   offset = "0 0 0";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = BowItem;
   ammo = " ";
   projectile = SACandyCaneProjectile;
   projectileType = Projectile;
   casing = "";
   shellExitDir        = "1.0 -1.3 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 15.0;	
   shellVelocity       = 7.0;
   melee = false;
   armReady = true;
   doColorShift = false;
   colorShiftColor = "0 0 0 0";
	stateName[0]                     = "Ready";
	stateTransitionOnTriggerDown[0]  = "Fire";
	stateAllowImageChange[0]         = true;
	stateSequence[0]	= "Ready";

	stateName[1]                    = "Fire";
	stateTransitionOnTimeout[1]     = "reload";
	stateTimeoutValue[1]            = 0.1;
	stateFire[1]                    = true;
	stateAllowImageChange[1]        = false;
	stateSequence[1]                = "Fire";
	stateScript[1]                  = "onFire";
	stateWaitForTimeout[1]			= true;
	stateEmitter[1]					= SACCFlashEmitter;
	stateEmitterTime[1]				= 0.05;
	stateEmitterNode[1]				= "muzzleNode";
	stateSound[1]					= SACCSound;

	stateName[2]			= "Reload";
	stateSequence[2]                = "Reload";
	stateTransitionOnTriggerUp[2]     = "Ready";
	stateSequence[2]	= "Ready";
	stateTransitionOnTimeout[2] = "Fire";
	stateTimeoutvalue = 0.05;

};
datablock ParticleData(SAPSFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.1 0.1 0.1 0.9";
	colors[1]     = "0 0 0 0.1";
	sizes[0]      = 1;
	sizes[1]      = 0;
};
datablock ParticleEmitterData(SAPSFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SAPSFlashParticle";
};
datablock ParticleData(SAPSExplosionParticleA)
{
   textureName          = "./fire";
   dragCoeffiecient     = 100.0;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.25;
   constantAcceleration = 0.1;
   lifetimeMS           = 1200;
   lifetimeVarianceMS   = 300;
   useInvAlpha =  false;
   spinRandomMin = -80.0;
   spinRandomMax =  80.0;

   colors[0]     = "0.8 0.4 0 0.8";
   colors[1]     = "0.2 0.0 0 0.8";
   colors[2]     = "0.0 0.0 0.0 0.0";

   sizes[0]      = 1.5;
   sizes[1]      = 0.9;
   sizes[2]      = 0.5;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(SAPSExplosionEmitterA)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 0.8;
   velocityVariance = 0.5;
   thetaMin         = 0.0;
   thetaMax         = 180.0;
   lifetimeMS       = 250;
   particles = "SAPSExplosionParticleA";
};


datablock ParticleData(SAPSExplosionParticleB)
{
   textureName          = "base/data/particles/cloud";
   dragCoeffiecient     = 100.0;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.25;
   constantAcceleration = -0.30;
   lifetimeMS           = 1200;
   lifetimeVarianceMS   = 300;
   useInvAlpha =  true;
   spinRandomMin = -80.0;
   spinRandomMax =  80.0;

   colors[0]     = "0.56 0.36 0.26 1.0";
   colors[1]     = "0.2 0.2 0.2 1.0";
   colors[2]     = "0.0 0.0 0.0 0.0";

   sizes[0]      = 8;
   sizes[1]      = 5;
   sizes[2]      = 2;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};
datablock ParticleEmitterData(SAPSExplosionEmitterB)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 0.5;
   thetaMin         = 0.0;
   thetaMax         = 180.0;
   lifetimeMS       = 250;
   particles = "SAPSExplosionParticleB";
};

datablock ExplosionData(SAPSExplosion)
{
   soundProfile = sapseSound;

   lifeTimeMS = 100;

   particleEmitter = SAPSExplosionEmitterA;
   particleDensity = 10;
   particleRadius = 4;

   emitter[0] = SAPSExplosionEmitterB;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 10;
   lightEndRadius = 0;
   lightStartColor = "1 0.5 0";
   lightEndColor = "0 0 0";
   damageRadius = 15;
   radiusDamage = 150;

   impulseRadius = 9;
   impulseForce = 100;
};


AddDamageType("SAPresent",'<bitmap:add-ons/Vehicle_SantaMech/CI_Present> %1','%2 <bitmap:add-ons/Vehicle_SantaMech/CI_Present> %1',0.2,1);
datablock ProjectileData(SAPresentProjectile)
{
   projectileShapeName = "./present.dts";
   directDamage        = 1000;
   directDamageType    = $DamageType::SAPresent;
   radiusDamageType    = $DamageType::SAPresent;

   brickExplosionRadius = 10;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 50;
   brickExplosionMaxVolume = 100;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 200;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 100;
   verticalImpulse	  = 100;
   explosion           = SAPSExplosion;
   particleEmitter     = "";

   muzzleVelocity      = 150;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 10000;
   fadeDelay           = 9000;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 1;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};
datablock ShapeBaseImageData(SAPSImage)
{
   shapeFile = "./emptygun.dts";
   emap = true;
   mountPoint = 2;
   offset = "0 0 0";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = BowItem;
   ammo = " ";
   projectile = SAPresentProjectile;
   projectileType = Projectile;
   casing = "";
   shellExitDir        = "1.0 -1.3 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 15.0;	
   shellVelocity       = 7.0;
   melee = false;
   armReady = true;
   doColorShift = false;
   colorShiftColor = "0 0 0 0";
	stateName[0]                     = "Ready";
	stateTransitionOnTriggerDown[0]  = "Fire";
	stateAllowImageChange[0]         = true;
	stateSequence[0]	= "Ready";

	stateName[1]                    = "Fire";
	stateTransitionOnTimeout[1]     = "reload";
	stateTimeoutValue[1]            = 0.1;
	stateFire[1]                    = true;
	stateAllowImageChange[1]        = false;
	stateSequence[1]                = "Fire";
	stateScript[1]                  = "onFire";
	stateWaitForTimeout[1]			= true;
	stateEmitter[1]					= SAPSFlashEmitter;
	stateEmitterTime[1]				= 0.05;
	stateEmitterNode[1]				= "muzzleNode";
	stateSound[1]					= SAPSSound;

	stateName[2]			= "Reload";
	stateSequence[2]                = "Reload";
	stateSequence[2]	= "Ready";
	stateTransitionOnTimeout[2] = "Ready";
	stateTimeoutvalue = 5;

};
package shootonclick_SA
{
	function armor::onTrigger(%db,%obj,%slot,%val)
	{
		if(%obj.getClassName()$="Player" && %obj.ismounted())
		{
			if(%obj.getobjectmount().getDatablock().getname() $="SAMechArmor")
			{
				if(%slot==0)
				{
					if(%val)
						%obj.getObjectmount().setImageTrigger(1,1);
					else
						%obj.getObjectmount().setImageTrigger(1,0);
				}
			}
		}
		Parent::onTrigger(%db,%obj,%slot,%val);
	}
	function servercmdLight(%client)
	{
		if(isObject(%client.player))
		{
			if(%client.player.isMounted())
			{
				if(%client.player.getobjectmount().getDatablock().getname() $="SAMechArmor")
				{
					%client.player.getobjectmount().setimageTrigger(2,1);
					%client.player.getobjectmount().setimagetrigger(2,0);
					return;
				}
			}
		}
		Parent::servercmdLight(%client);
	}
	function armor::onMount(%this,%obj,%col,%slot)
	{
		Parent::onMount(%this,%obj,%col,%slot);
		if(%col.getDataBlock().getName() $= "SAMechArmor")
		{
			%col.client = %obj.client;
		}
	}
	function SAMechArmor::onDriverLeave(%this,%obj)
	{
		Parent::onUnmount(%this,%obj);
		%obj.client = "";
	}
};
ActivatePackage(shootonclick_SA);
function SAMechArmor::onAdd(%this,%obj)
{
	%obj.mountImage(SACCImage,1);
	%obj.mountImage(SAPSImage,2);
}